/*  File   : html.c
    Author : Richard A. O'Keefe
    Updated: 2011/02/02
    Purpose: Output tables for generating HTML.
*/

#ifndef	lint
static	char SCCSid[] = "@(#)11/02/02 html.c	1.9";
#endif/*lint*/

#include "formatter.h"


static char const empty[] = "";
static char const efont[] = "</font>";


static char const* const Start_Style[] = {
    empty,
    "<I>",
    "<B>",
    "<B><I>",
    "<U>",
    "<U><I>",
    "<U><B>",
    "<U><B><I>",
    "<TT>",
    "<TT><I>",
    "<TT><B>",
    "<TT><B><I>",
    "<TT><U>",
    "<TT><U><I>",
    "<TT><U><B>",
    "<TT><U><B><I>"
};


static char const *const End_Style[] = {
    empty,
    "</I>",
    "</B>",
    "</I></B>",
    "</U>",
    "</I></U>",
    "</B></U>",
    "</I></B></U>",
    "</TT>",
    "</I></TT>",
    "</B></TT>",
    "</I></B></TT>",
    "</U></TT>",
    "</I></U></TT>",
    "</B></U></TT>",
    "</I></B></U></TT>"
};


static char const unknown[] = "&curren;";

static char const *const Char_Map[] = {
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    " ",        /*   */
    "!",        /* ! */
    "&quot;",   /* " */
    "#",        /* # */
    "$",        /* $ */
    "%",        /* % */
    "&amp;",    /* & */
    "'",        /* ' */
    "(",        /* ( */
    ")",        /* ) */
    "*",        /* * */
    "+",        /* + */
    ",",        /* , */
    "-",        /* - */
    ".",        /* . */
    "/",        /* / */
    "0",        /* 0 */
    "1",        /* 1 */
    "2",        /* 2 */
    "3",        /* 3 */
    "4",        /* 4 */
    "5",        /* 5 */
    "6",        /* 6 */
    "7",        /* 7 */
    "8",        /* 8 */
    "9",        /* 9 */
    ":",        /* : */
    ";",        /* ; */
    "&lt;",     /* < */
    "=",        /* = */
    "&gt;",     /* > */
    "?",        /* ? */
    "@",        /* @ */
    "A",        /* A */
    "B",        /* B */
    "C",        /* C */
    "D",        /* D */
    "E",        /* E */
    "F",        /* F */
    "G",        /* G */
    "H",        /* H */
    "I",        /* I */
    "J",        /* J */
    "K",        /* K */
    "L",        /* L */
    "M",        /* M */
    "N",        /* N */
    "O",        /* O */
    "P",        /* P */
    "Q",        /* Q */
    "R",        /* R */
    "S",        /* S */
    "T",        /* T */
    "U",        /* U */
    "V",        /* V */
    "W",        /* W */
    "X",        /* X */
    "Y",        /* Y */
    "Z",        /* Z */
    "[",        /* [ */
    "\\",       /* \ */
    "]",        /* ] */
    "^",        /* ^ */
    "_",        /* _ */
    "`",        /* ` */
    "a",        /* a */
    "b",        /* b */
    "c",        /* c */
    "d",        /* d */
    "e",        /* e */
    "f",        /* f */
    "g",        /* g */
    "h",        /* h */
    "i",        /* i */
    "j",        /* j */
    "k",        /* k */
    "l",        /* l */
    "m",        /* m */
    "n",        /* n */
    "o",        /* o */
    "p",        /* p */
    "q",        /* q */
    "r",        /* r */
    "s",        /* s */
    "t",        /* t */
    "u",        /* u */
    "v",        /* v */
    "w",        /* w */
    "x",        /* x */
    "y",        /* y */
    "z",        /* z */
    "{",        /* { */
    "|",        /* | */
    "}",        /* } */
    "~",        /* ~ */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    "&nbsp;",   /* no-break space */
    "&iexcl;",  /* inverted exclamation mark */
    "&cent;",   /* cent sign */
    "&pound;",  /* pound sterling sign */
    "&curren;", /* general currency sign */
    "&yen;",    /* yen sign */
    "&brvbar;", /* broken (vertical) bar */
    "&sect;",   /* section sign */
    "&uml;",    /* umlaut (dieresis) */
    "&copy;",   /* copyright sign */
    "&ordf;",   /* ordinal indicator, feminine */
    "&laquo;",  /* angle quotation mark, left */
    "&not;",    /* not sign */
    "&shy;",    /* soft hyphen */
    "&reg;",    /* registered sign */
    "&macr;",   /* macron */
    "&deg;",    /* degree sign */
    "&plusmn;", /* plus-or-minus sign */
    "&sup2;",   /* superscript two */
    "&sup3;",   /* superscript three */
    "&acute;",  /* acute accent */
    "&micro;",  /* micro sign */
    "&para;",   /* pilcrow (paragraph sign) */
    "&middot;", /* middle dot */
    "&cedil;",  /* cedilla */
    "&sup1;",   /* superscript one */
    "&ordm;",   /* ordinal indicator, masculine */
    "&raquo;",  /* angle quotation mark, right */
    "&frac14;", /* fraction one-quarter */
    "&frac12;", /* fraction one-half */
    "&frac34;", /* fraction three-quarters */
    "&iquest;", /* inverted question mark */
    "&Agrave;", /* capital A, grave accent */
    "&Aacute;", /* capital A, acute accent */
    "&Acirc;",  /* capital A, circumflex accent */
    "&Atilde;", /* capital A, tilde */
    "&Auml;",   /* capital A, dieresis or umlaut mark */
    "&Aring;",  /* capital A, ring */
    "&AElig;",  /* capital AE diphthong (ligature) */
    "&Ccedil;", /* capital C, cedilla */
    "&Egrave;", /* capital E, grave accent */
    "&Eacute;", /* capital E, acute accent */
    "&Ecirc;",  /* capital E, circumflex accent */
    "&Euml;",   /* capital E, dieresis or umlaut mark */
    "&Igrave;", /* capital I, grave accent */
    "&Iacute;", /* capital I, acute accent */
    "&Icirc;",  /* capital I, circumflex accent */
    "&Iuml;",   /* capital I, dieresis or umlaut mark */
    "&ETH;",    /* capital Eth, Icelandic */
    "&Ntilde;", /* capital N, tilde */
    "&Ograve;", /* capital O, grave accent */
    "&Oacute;", /* capital O, acute accent */
    "&Ocirc;",  /* capital O, circumflex accent */
    "&Otilde;", /* capital O, tilde */
    "&Ouml;",   /* capital O, dieresis or umlaut mark */
    "&times;",  /* multiply sign */
    "&Oslash;", /* capital O, slash */
    "&Ugrave;", /* capital U, grave accent */
    "&Uacute;", /* capital U, acute accent */
    "&Ucirc;",  /* capital U, circumflex accent */
    "&Uuml;",   /* capital U, dieresis or umlaut mark */
    "&Yacute;", /* capital Y, acute accent */
    "&THORN;",  /* capital THORN, Icelandic */
    "&szlig;",  /* small sharp s, German (sz ligature) */
    "&agrave;", /* small a, grave accent */
    "&aacute;", /* small a, acute accent */
    "&acirc;",  /* small a, circumflex accent */
    "&atilde;", /* small a, tilde */
    "&auml;",   /* small a, dieresis or umlaut mark */
    "&aring;",  /* small a, ring */
    "&aelig;",  /* small ae diphthong (ligature) */
    "&ccedil;", /* small c, cedilla */
    "&egrave;", /* small e, grave accent */
    "&eacute;", /* small e, acute accent */
    "&ecirc;",  /* small e, circumflex accent */
    "&euml;",   /* small e, dieresis or umlaut mark */
    "&igrave;", /* small i, grave accent */
    "&iacute;", /* small i, acute accent */
    "&icirc;",  /* small i, circumflex accent */
    "&iuml;",   /* small i, dieresis or umlaut mark */
    "&eth;",    /* small eth, Icelandic */
    "&ntilde;", /* small n, tilde */
    "&ograve;", /* small o, grave accent */
    "&oacute;", /* small o, acute accent */
    "&ocirc;",  /* small o, circumflex accent */
    "&otilde;", /* small o, tilde */
    "&ouml;",   /* small o, dieresis or umlaut mark */
    "&divide;", /* divide sign */
    "&oslash;", /* small o, slash */
    "&ugrave;", /* small u, grave accent */
    "&uacute;", /* small u, acute accent */
    "&ucirc;",  /* small u, circumflex accent */
    "&uuml;",   /* small u, dieresis or umlaut mark */
    "&yacute;", /* small y, acute accent */
    "&thorn;",  /* small thorn, Icelandic */
    "&yuml;",   /* small y, dieresis or umlaut mark */
};


#define write_html_string(s) put_mapped((unsigned char const *)(s), &html)


static void meta(char const *name1, char const *name2, char const *val) {
    put_string("<META ");
    put_string(name1);
    put_string("=\"");
    write_html_string(name2);
    put_string("\" content=\"");
    write_html_string(val);
    put_string("\">\n");
}


static void begin_output(
    char const *author,
    char const *date,
    char const *title1,
    char const *title2
) {
    put_string("<!Doctype HTML PUBLIC \"-//IETF//DTD HTML 3.2//EN\">\n");
    put_string("<HTML>\n");
    put_string("<HEAD>\n");
    meta("HTTP-Equiv", "Content-Type", "text/html; charset=ASCII");
    meta("HTTP-Equiv", "Editor", "many2h.otago.ac.nz");
    if (author != 0 && *author != 0) meta("name", "author", author);
    if (date   != 0 && *date   != 0) meta("name", "date",   date);
    if (title1 != 0 && *title1 != 0) {
	put_string("<TITLE>\n");
	write_html_string(title1);
	if (title2 != 0 && *title2 != 0) write_html_string(title2);
	put_string("\n</TITLE>\n");
    }
    put_string("</HEAD>\n");
    put_string("<BODY BGCOLOR=\"white\" TEXT=\"black\">\n");
}


static void end_output(void) {
    put_string("</BODY>\n");
    put_string("</HTML>\n");
}


static void begin_section(char const *title) {
    if (title != 0 && *title != 0) {
	put_string("<H1>");
	write_html_string(title);
	put_string("</H1>\n");
    }
    put_string("<PRE>\n");
}


static void end_section(void) {
    put_string("</PRE>\n");
}


static void finish_line(void) {
    put_string("\n");
}


static void tab_from_to(int from, int to) {
    put_spaces(to-from);
}


struct Formatter html = {
    Start_Style,
    End_Style,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};


static char const *const Coloured_Start[] = {
    empty,			/* plain */
    "<font color=blue>",	/* italic (comment = blue) */
    "<font color=red>",		/* bold (keyword = red) */
    "<font color=yellow>",	/* bold italic */
    "<font color=lime>",	/* underline (lime) */
    "<font color=lime>",	/* underline italic (lime) */
    "<font color=purple>",	/* underline bold */
    "<font color=purple>",	/* underline bold italic */
    "<font color=fuchsia>",	/* typewriter plain (string = fuchsia) */
    "<font color=fuchsia>",	/* typewriter italic */
    "<font color=fuchsia>",	/* typewriter bold */
    "<font color=fuchsia>",	/* typewriter bold italic */
    "<font color=fuchsia>",	/* typewriter underline */
    "<font color=fuchsia>",	/* typewriter underline italic */
    "<font color=fuchsia>",	/* typewriter underline bold */
    "<font color=fuchsia>"	/* typewriter underline bold italic */
};


static char const *const Coloured_End[] = {
    empty,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont,
    efont
};


struct Formatter chtml = {
    Coloured_Start,
    Coloured_End,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};


