/*  Header : language.h
    Author : Richard A. O'Keefe
    Updated: 2011/02/02
    Purpose: Interface for tokenisers.
*/

enum CsSns {
    Not_Case_Sensitive = 0,
    Is_Case_Sensitive = 1
};

struct Language {
    char const *name;
    char const *suffixes;
    char const *lbracks;
    char const *rbracks;
    char const *unders;
    char const *specials;
    char        escaper;
    char        opchar;	    /* Fortran .xxx. Haskell `xxx` R/S %xxx% */
    enum CsSns  case_sensitive;
    char      **keywords;
    void      (*tokenise)(void);
};

extern struct Language ada;
extern struct Language awk;
extern struct Language pascal;
extern struct Language eiffel;
extern struct Language erlang;
extern struct Language c89;
extern struct Language cpp;
extern struct Language d04;
extern struct Language haskell;
extern struct Language java;
extern struct Language mercury;
extern struct Language nqc;
extern struct Language opl;
extern struct Language prolog;
extern struct Language R;
extern struct Language raw;
extern struct Language rpcl;
extern struct Language scm;
extern struct Language sgml;
extern struct Language sml;
extern struct Language sql;
extern struct Language st80;

extern void init_ctype(int, struct Language const *);
extern void add_kinded_keyword(char const *, size_t, int);

extern struct Language const *opt_lang(char const *);
extern struct Language const *ext_lang(char const *);

