/*  File   : plain.c
    Author : Richard A. O'Keefe
    Updated: 2011/02/02
    Purpose: Output tables for generating text with no markup.
*/

#ifndef	lint
static	char SCCSid[] = "@(#)11/02/02 plain.c	1.12";
#endif/*lint*/

#include "formatter.h"


static char const empty[] = "";

static char const* const Plain_Start[] = {
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty
};


static char const *const Plain_End[] = {
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty,
    empty
};


static char const unknown[] = "?";

static char const *const Char_Map[] = {
    empty,      /* Control @ */
    unknown,    /* Control A */
    unknown,    /* Control B */
    unknown,    /* Control C */
    unknown,    /* Control D */
    unknown,    /* Control E */
    unknown,    /* Control F */
    unknown,    /* Control G */
    "\b",       /* Control H */
    "\t",       /* Control I */
    "\n",       /* Control J */
    unknown,    /* Control K */
    "\f",       /* Control L */
    empty,      /* Control M */
    unknown,    /* Control N */
    unknown,    /* Control O */
    unknown,    /* Control P */
    unknown,    /* Control Q */
    unknown,    /* Control R */
    unknown,    /* Control S */
    unknown,    /* Control T */
    unknown,    /* Control U */
    unknown,    /* Control V */
    unknown,    /* Control W */
    unknown,    /* Control X */
    unknown,    /* Control Y */
    unknown,    /* Control Z */
    unknown,    /* Control [ */
    unknown,    /* Control \ */
    unknown,    /* Control ] */
    unknown,    /* Control ^ */
    unknown,    /* Control _ */
    " ",        /*   */
    "!",        /* ! */
    "\"",       /* " */
    "#",        /* # */
    "$",        /* $ */
    "%",        /* % */
    "&",        /* & */
    "'",        /* ' */
    "(",        /* ( */
    ")",        /* ) */
    "*",        /* * */
    "+",        /* + */
    ",",        /* , */
    "-",        /* - */
    ".",        /* . */
    "/",        /* / */
    "0",        /* 0 */
    "1",        /* 1 */
    "2",        /* 2 */
    "3",        /* 3 */
    "4",        /* 4 */
    "5",        /* 5 */
    "6",        /* 6 */
    "7",        /* 7 */
    "8",        /* 8 */
    "9",        /* 9 */
    ":",        /* : */
    ";",        /* ; */
    "<",        /* < */
    "=",        /* = */
    ">",        /* > */
    "?",        /* ? */
    "@",        /* @ */
    "A",        /* A */
    "B",        /* B */
    "C",        /* C */
    "D",        /* D */
    "E",        /* E */
    "F",        /* F */
    "G",        /* G */
    "H",        /* H */
    "I",        /* I */
    "J",        /* J */
    "K",        /* K */
    "L",        /* L */
    "M",        /* M */
    "N",        /* N */
    "O",        /* O */
    "P",        /* P */
    "Q",        /* Q */
    "R",        /* R */
    "S",        /* S */
    "T",        /* T */
    "U",        /* U */
    "V",        /* V */
    "W",        /* W */
    "X",        /* X */
    "Y",        /* Y */
    "Z",        /* Z */
    "[",        /* [ */
    "\\",       /* \ */
    "]",        /* ] */
    "^",        /* ^ */
    "_",        /* _ */
    "`",        /* ` */
    "a",        /* a */
    "b",        /* b */
    "c",        /* c */
    "d",        /* d */
    "e",        /* e */
    "f",        /* f */
    "g",        /* g */
    "h",        /* h */
    "i",        /* i */
    "j",        /* j */
    "k",        /* k */
    "l",        /* l */
    "m",        /* m */
    "n",        /* n */
    "o",        /* o */
    "p",        /* p */
    "q",        /* q */
    "r",        /* r */
    "s",        /* s */
    "t",        /* t */
    "u",        /* u */
    "v",        /* v */
    "w",        /* w */
    "x",        /* x */
    "y",        /* y */
    "z",        /* z */
    "{",        /* { */
    "|",        /* | */
    "}",        /* } */
    "~",        /* ~ */
    unknown,    /* DEL */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    unknown,    /* CONTROL CHARACTER */
    "\xa0",     /* no-break space */
    "\xa1",     /* inverted exclamation mark */
    "\xa2",     /* cent sign */
    "\xa3",     /* pound sterling sign */
    "\xa4",     /* general currency sign */
    "\xa5",     /* yen sign */
    "\xa6",     /* broken (vertical) bar */
    "\xa7",     /* section sign */
    "\xa8",     /* umlaut (dieresis) */
    "\xa9",     /* copyright sign */
    "\xaa",     /* ordinal indicator, feminine */
    "\xab",     /* angle quotation mark, left */
    "\xac",     /* not sign */
    "\xad",     /* soft hyphen */
    "\xae",     /* registered sign */
    "\xaf",     /* macron */
    "\xb0",     /* degree sign */
    "\xb1",     /* plus-or-minus sign */
    "\xb2",     /* superscript two */
    "\xb3",     /* superscript three */
    "\xb4",     /* acute accent */
    "\xb5",     /* micro sign */
    "\xb6",     /* pilcrow (paragraph sign) */
    "\xb7",     /* middle dot */
    "\xb8",     /* cedilla */
    "\xb9",     /* superscript one */
    "\xba",     /* ordinal indicator, masculine */
    "\xbb",     /* angle quotation mark, right */
    "\xbc",     /* fraction one-quarter */
    "\xbd",     /* fraction one-half */
    "\xbe",     /* fraction three-quarters */
    "\xbf",     /* inverted question mark */
    "\xc0",     /* capital A, grave accent */
    "\xc1",     /* capital A, acute accent */
    "\xc2",     /* capital A, circumflex accent */
    "\xc3",     /* capital A, tilde */
    "\xc4",     /* capital A, dieresis or umlaut mark */
    "\xc5",     /* capital A, ring */
    "\xc6",     /* capital AE diphthong (ligature) */
    "\xc7",     /* capital C, cedilla */
    "\xc8",     /* capital E, grave accent */
    "\xc9",     /* capital E, acute accent */
    "\xca",     /* capital E, circumflex accent */
    "\xcb",     /* capital E, dieresis or umlaut mark */
    "\xcc",     /* capital I, grave accent */
    "\xcd",     /* capital I, acute accent */
    "\xce",     /* capital I, circumflex accent */
    "\xcf",     /* capital I, dieresis or umlaut mark */
    "\xd0",     /* capital Eth, Icelandic */
    "\xd1",     /* capital N, tilde */
    "\xd2",     /* capital O, grave accent */
    "\xd3",     /* capital O, acute accent */
    "\xd4",     /* capital O, circumflex accent */
    "\xd5",     /* capital O, tilde */
    "\xd6",     /* capital O, dieresis or umlaut mark */
    "\xd7",     /* multiply sign */
    "\xd8",     /* capital O, slash */
    "\xd9",     /* capital U, grave accent */
    "\xda",     /* capital U, acute accent */
    "\xdb",     /* capital U, circumflex accent */
    "\xdc",     /* capital U, dieresis or umlaut mark */
    "\xdd",     /* capital Y, acute accent */
    "\xde",     /* capital THORN, Icelandic */
    "\xdf",     /* small sharp s, German (sz ligature) */
    "\xe0",     /* small a, grave accent */
    "\xe1",     /* small a, acute accent */
    "\xe2",     /* small a, circumflex accent */
    "\xe3",     /* small a, tilde */
    "\xe4",     /* small a, dieresis or umlaut mark */
    "\xe5",     /* small a, ring */
    "\xe6",     /* small ae diphthong (ligature) */
    "\xe7",     /* small c, cedilla */
    "\xe8",     /* small e, grave accent */
    "\xe9",     /* small e, acute accent */
    "\xea",     /* small e, circumflex accent */
    "\xeb",     /* small e, dieresis or umlaut mark */
    "\xec",     /* small i, grave accent */
    "\xed",     /* small i, acute accent */
    "\xee",     /* small i, circumflex accent */
    "\xef",   /* small i, dieresis or umlaut mark */
    "\xf0",    /* small eth, Icelandic */
    "\xf1", /* small n, tilde */
    "\xf2", /* small o, grave accent */
    "\xf3", /* small o, acute accent */
    "\xf4",  /* small o, circumflex accent */
    "\xf5", /* small o, tilde */
    "\xf6",   /* small o, dieresis or umlaut mark */
    "\xf7", /* divide sign */
    "\xf8", /* small o, slash */
    "\xf9", /* small u, grave accent */
    "\xfa", /* small u, acute accent */
    "\xfb",  /* small u, circumflex accent */
    "\xfc",   /* small u, dieresis or umlaut mark */
    "\xfd", /* small y, acute accent */
    "\xfe",  /* small thorn, Icelandic */
    "\xff",   /* small y, dieresis or umlaut mark */
};


			/*ARGSUSED*/
static void begin_output(
    char const *author,
    char const *date,
    char const *title1,
    char const *title2
) {}
static void end_output(void) {}

				/*ARGSUSED*/
static void begin_section(char const *title) {}
static void end_section(void) {}


static void finish_line(void) {
    put_string("\n");
}


static void tab_from_to(int from, int to) {
    put_spaces(to-from);
}


struct Formatter plain = {
    Plain_Start,
    Plain_End,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};


#define SG(n) "\033[" n "m"

static char const *ANSI_Start[] = {
    empty,		/* plain */
    SG("4"),		/* italic */
    SG("1"),		/* bold */
    SG("1;4"),		/* bold italic */
    SG("4"),		/* underline */
    SG("4"),		/* underline italic */
    SG("1;4"),		/* underline bold */
    SG("1;4"),		/* underline bold italic */
    empty,		/* typewriter plain */
    SG("4"),		/* typewriter italic */
    SG("1"),		/* typewriter bold */
    SG("1;4"),		/* typewriter bold italic */
    SG("4"),		/* typewriter underline */
    SG("4"),		/* typewriter underline italic */
    SG("1;4"),		/* typewriter underline bold */
    SG("1;4")		/* typewriter underline bold italic */
};    

static char const all_clear[] = SG("0");

static char const *ANSI_End[] = {
    empty,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear,
    all_clear
};    


struct Formatter ansi = {
    ANSI_Start,
    ANSI_End,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};


static char const *Coloured_Start[] = {
    empty,		/* plain */
    SG("34"),		/* italic (comment = blue) */
    SG("31"),		/* bold (keyword = red) */
    SG("33"),		/* bold italic (yellow) */
    SG("34"),		/* underline (blue) */
    SG("34"),		/* underline italic */
    SG("34"),		/* underline bold */
    SG("34"),		/* underline bold italic */
    SG("35"),   	/* typewriter plain */
    SG("36"),		/* typewriter italic */
    SG("36"),		/* typewriter bold */
    SG("36"),		/* typewriter bold italic */
    SG("34"),		/* typewriter underline */
    SG("34"),		/* typewriter underline italic */
    SG("34"),		/* typewriter underline bold */
    SG("34")		/* typewriter underline bold italic */
};    


struct Formatter colour = {
    Coloured_Start,
    ANSI_End,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};

		
static void do_not_finish_line(void) {
}

				/*ARGSUSED*/
static void do_not_tab_from_to(int from, int to) {
    (void)from;
    (void)to;
}


static void end_token(enum Token_Type type) {
    switch (type) {
	case String_Opener:
	case String_Element:
	case Comment_Opener:
	case Comment_Element:
	    break;
	default:
	    put_plain((unsigned char const *)"\n");
    }
}


struct Formatter one_per_line = {
    Plain_Start,
    Plain_End,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    do_not_tab_from_to,
    end_token,
    do_not_finish_line
};

