/*  File   : raw.c
    Author : Richard A. O'Keefe
    Updated: 2011/02/02
    Purpose: Tokeniser for turning "raw" text into HTML or LaTeX.
*/

#ifndef	lint
static	char SCCSid[] = "@(#)11/02/02 raw.c	1.4";
#endif/*lint*/

#include "many2h.h"
#include "language.h"


static void tokenise(void) {
    int column;

    for (column = 0; line_buffer[column] == ' '; column++) {}
    token_row[0].type   = Identifier;
    token_row[0].start  = column;
    token_row[0].text   = &line_buffer[column];
    token_row[0].length = line_length - column;
    token_row[1].type   = End_Of_Line;
    token_row[1].start  = line_length;
    token_row[1].text   = &line_buffer[line_length];
    token_row[1].length = 0;
}

static char *keywords[] = {
    (char*)0
};

struct Language raw = {
    "Raw text",
    ".txt.doc",
    "([{",
    ")]}",
    "-",
    "",
    '\0',
    '\0',
    Not_Case_Sensitive,
    keywords,
    tokenise
};


