/*  File   : roff.c
    Author : Richard A. O'Keefe
    Updated: 2011/02/02
    Purpose: Output table for generating *roff.
*/

#ifndef	lint
static	char SCCSid[] = "@(#)11/02/02 roff.c	1.7";
#endif/*lint*/


#include "formatter.h"


static char const empty[] = "";
static const char unknown[] = "\\fB?\\fp";

static char const* const Start_Style[] = {
#ifndef NOCOURIER
    "\\fR",
    "\\fI",
    "\\fB",
    "\\f(BI",
    "\\fR",
    "\\fI",
    "\\fB",
    "\\f(BI",
    "\\f(CW",
    "\\f(CI",
    "\\f(CB",
    "\\f(CX",
    "\\f(CW",
    "\\f(CI",
    "\\f(CB",
    "\\f(CX",
#else
    empty,
    "\\fI",
    "\\fB",
    "\\f(BI",
    empty,
    "\\fI",
    "\\fB",
    "\\f(BI",
    empty,
    "\\fI",
    "\\fB",
    "\\f(BI",
    empty,
    "\\fI",
    "\\fB",
    "\\f(BI"
#endif
};

static char const *const End_Style[] = {
#ifndef NOCOURIER
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
    "\\fP",
#else
    empty,
    "\\fR",
    "\\fR",
    "\\fR",
    empty,
    "\\fR",
    "\\fR",
    "\\fR",
    empty,
    "\\fR",
    "\\fR",
    "\\fR",
    empty,
    "\\fR",
    "\\fR",
    "\\fR"
#endif
};

static char const *const Char_Map[] = {
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    " ",          /*   */
    "!",          /* ! */
    "\"",         /* " */
    "#",          /* # */
    "$",          /* $ */
    "%",          /* % */
    "&",          /* & */
    "\'",         /* ' */
    "(",          /* ( */
    ")",          /* ) */
    "*",          /* * */
    "+",          /* + */
    ",",          /* , */
    "-",          /* - */
    ".",          /* . */
    "/",          /* / */
    "0",          /* 0 */
    "1",          /* 1 */
    "2",          /* 2 */
    "3",          /* 3 */
    "4",          /* 4 */
    "5",          /* 5 */
    "6",          /* 6 */
    "7",          /* 7 */
    "8",          /* 8 */
    "9",          /* 9 */
    ":",          /* : */
    ";",          /* ; */
    "<",          /* < */
    "=",          /* = */
    ">",          /* > */
    "?",          /* ? */
    "@",          /* @ */
    "A",          /* A */
    "B",          /* B */
    "C",          /* C */
    "D",          /* D */
    "E",          /* E */
    "F",          /* F */
    "G",          /* G */
    "H",          /* H */
    "I",          /* I */
    "J",          /* J */
    "K",          /* K */
    "L",          /* L */
    "M",          /* M */
    "N",          /* N */
    "O",          /* O */
    "P",          /* P */
    "Q",          /* Q */
    "R",          /* R */
    "S",          /* S */
    "T",          /* T */
    "U",          /* U */
    "V",          /* V */
    "W",          /* W */
    "X",          /* X */
    "Y",          /* Y */
    "Z",          /* Z */
    "[",          /* [ */
    "\\\\",       /* \ */
    "]",          /* ] */
    "^",          /* ^ */
    "_",          /* _ */
    "`",          /* ` */
    "a",          /* a */
    "b",          /* b */
    "c",          /* c */
    "d",          /* d */
    "e",          /* e */
    "f",          /* f */
    "g",          /* g */
    "h",          /* h */
    "i",          /* i */
    "j",          /* j */
    "k",          /* k */
    "l",          /* l */
    "m",          /* m */
    "n",          /* n */
    "o",          /* o */
    "p",          /* p */
    "q",          /* q */
    "r",          /* r */
    "s",          /* s */
    "t",          /* t */
    "u",          /* u */
    "v",          /* v */
    "w",          /* w */
    "x",          /* x */
    "y",          /* y */
    "z",          /* z */
    "{",          /* { */
    "|",          /* | */
    "}",          /* } */
    "~",          /* ~ */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    unknown,                 /* CONTROL CHARACTER */
    "\\ ",                   /* no-break space */
    "x",                     /* ? inverted exclamation mark */
    "\\ct",                  /* ? cent sign */
    "\\z=L",                 /* ? pound sterling sign */
    "g",                     /* ? general currency sign */
    "\\z=Y",                 /* ? yen sign */
    "\\br", 	             /* ? broken (vertical) bar */
    "\\(ss",                 /* section sign */
    "\\(: ",                 /* umlaut (dieresis) */
    "\\(co",                 /* copyright sign */
    "a",                     /* ? ordinal indicator, feminine */
    "\\*(Q",                 /* angle quotation mark, left [wrong] */
    "\\no",                  /* ? not sign */
    "-",                     /* soft hyphen */
    "\\rg",                  /* registered sign */
    "-",                     /* macron */
    "\\(de",                 /* degree sign */
    "\\(pm",                 /* plus-or-minus sign */
    "2",                     /* superscript two */
    "3",                     /* superscript three */
    "\\*' ",                 /* acute accent */
    "\\(*m",                 /* micro sign */
    "P",                     /* pilcrow (paragraph sign) */
    ".",                     /* middle dot */
    "\\*, ",                 /* cedilla; close but no cigar */
    "1",                     /* superscript one */
    "o",                     /* ordinal indicator, masculine */
    "\\*U",                  /* angle quotation mark, right [wrong] */
    "\\(14",                 /* fraction one-quarter */
    "\\(12",                 /* fraction one-half */
    "\\(34",                 /* fraction three-quarters */
    "?",                     /* inverted question mark */
    "\\*`A",                /* capital A, grave accent */
    "\\*'A",                /* capital A, acute accent */
    "\\*^A",                /* capital A, circumflex accent */
    "\\*~A",                /* capital A, tilde */
    "\\*:A",                /* capital A, dieresis or umlaut mark */
    "A",                    /* ? capital A, ring */
    "\\(Ae",                /* capital AE diphthong (ligature) */
    "\\*,C",                /* capital C, cedilla */
    "\\*`E",                /* capital E, grave accent */
    "\\*'E",                /* capital E, acute accent */
    "\\*^E",                /* capital E, circumflex accent */
    "\\*:E",                /* capital E, dieresis or umlaut mark */
    "\\*`I",                /* capital I, grave accent */
    "\\*'I",                /* capital I, acute accent */
    "\\*^I",                /* capital I, circumflex accent */
    "\\*:I",                /* capital I, dieresis or umlaut mark */
    "Dh",                   /* capital Eth, Icelandic; WRONG */
    "\\*~N",                /* capital N, tilde */
    "\\*`O",                /* capital O, grave accent */
    "\\*'O",                /* capital O, acute accent */
    "\\*^O",                /* capital O, circumflex accent */
    "\\*~O",                /* capital O, tilde */
    "\\*:O",                /* capital O, dieresis or umlaut mark */
    "\\mu",                 /* multiply sign */
    "\\*O",                 /* capital O, slash */
    "\\*`U",                /* capital U, grave accent */
    "\\*'U",                /* capital U, acute accent */
    "\\*^U",                /* capital U, circumflex accent */
    "\\*:U",                /* capital U, dieresis or umlaut mark */
    "\\*'Y",                /* capital Y, acute accent */
    "\\(Th",                /* capital THORN, Icelandic */
    "\\(ss",                /* small sharp s, German (sz ligature) */
    "\\*`a",	            /* small a, grave accent */
    "\\*'a",                /* small a, acute accent */
    "\\*^a",                /* small a, circumflex accent */
    "\\*~a",                /* small a, tilde */
    "\\*:a",                /* small a, dieresis or umlaut mark */
    "a",                    /* ? small a, ring */
    "\\(ae",                /* small ae diphthong (ligature) */
    "\\*,c",                /* small c, cedilla */
    "\\*`e",                /* small e, grave accent */
    "\\*'e",                /* small e, acute accent */
    "\\*^e",                /* small e, circumflex accent */
    "\\*:e",                /* small e, dieresis or umlaut mark */
    "\\*`i",                /* small i, grave accent */
    "\\*'i",                /* small i, acute accent */
    "\\*^i",                /* small i, circumflex accent */
    "\\*:i",                /* small i, dieresis or umlaut mark */
    "dh",                   /* small eth, Icelandic; WRONG */
    "\\*~n",                /* small n, tilde */
    "\\*`o",                /* small o, grave accent */
    "\\*'o",                /* small o, acute accent */
    "\\*^o",                /* small o, circumflex accent */
    "\\*~o",                /* small o, tilde */
    "\\*:o",                /* small o, dieresis or umlaut mark */
    "\\(di",                /* divide sign */
    "\\*o",                 /* small o, slash */
    "\\*`u",                /* small u, grave accent */
    "\\*'u",                /* small u, acute accent */
    "\\*^u",                /* small u, circumflex accent */
    "\\*:u",                /* small u, dieresis or umlaut mark */
    "\\*'y",                /* small y, acute accent */
    "\\(th",                /* small thorn, Icelandic; WRONG */
    "\\*:y",                /* small y, dieresis or umlaut mark */
};


#define write_roff_string(s) put_mapped((unsigned char const *)(s), &roff)

static void show(char const *tag, char const *val1, char const *val2) {
    put_string(".");
    put_string(tag);
    put_string(" ");
    write_roff_string(val1);
    if (val2 != 0 && *val2 != 0) write_roff_string(val2);
    put_string("\n");
}


static void begin_output(
    char const *author,
    char const *date,
    char const *title1,
    char const *title2
) {
    put_string(".\" Generated by many2h\n");
    put_string(".\" Use | troff -me -Tpost | dpost\n");
#ifndef NOCOURIER
    put_string(".ft CW\n");
#endif
    put_string(".nr PI 0\n");
    put_string(".ls 1\n");
    put_string(".na\n");
    if (title1 != 0 && *title1 != 0) show("PT", title1, title2);
    if (author != 0 && *author != 0) show("AU", author, "");
    if (date   != 0 && *date   != 0) show("BT", date, "");
}


static void end_output(void) {
    show("PP", "", "");
}


static void begin_section(char const *title) {
    if (title != 0 && *title != 0) show("SH", title, "");
    show("LP", "", "");
}


static void end_section(void) {
}


static void finish_line(void) {
    put_string("\n");
    show("br", "", "");
}


static void tab_from_to(int from, int to) {
    if (to > from) {
	put_spaces(to-from);
    }
}


struct Formatter roff = {
    Start_Style,
    End_Style,
    Char_Map,
    begin_output,
    end_output,
    begin_section,
    end_section,
    tab_from_to,
    no_end_token,
    finish_line
};

