implementation module pq

:: PQ k v = PQ_MT | PQ_LF k v Int [???]

empty_pq :: PQ k v | Ord k
empty_pq = PQ_MT

pq_is_empty :: (PQ k v) -> Bool | Ord k
pq_is_empty (PQ_MT)         = True
pq_is_empty (PQ_LF _ _ _ _) = False

pq_insert_entry :: (k,v) (PQ k v) -> (PQ k v) | Ord k
pq_insert_entry (k,v) q = pq_insert k v q

pq_insert :: k v (PQ k v) -> (PQ k v) | Ord k
pq_insert k v (PQ_MT) = (PQ_LF k v 0 [])
pq_insert k v q=:(PQ_LF k2 v2 _ l2)
  | k <= k2 = PQ_LF k v 0 [t]
  | True    = PQ_LF k2 v2 0 (skew_insert (PQ_LF k v 0 []) l2)

pq_meld :: (PQ k v) (PQ k v) -> (PQ k v) | Ord k
pq_meld (PQ_MT) q = q
pq_meld q (PQ_MT) = q
pq_meld q1=:(PQ_LF k1 v1 _ l1) q2=:(PQ_LF k2 v2 _ l2)
  | k1 <= k2 = PQ_LF k1 v1 0 (skew_insert q2 l1)
  | True     = PQ_LF k2 v2 0 (skew_insert q1 l2)

pq_min_entry :: (PQ k v) -> (k,v) | Ord k
pq_min_entry (PQ_LF k v _ _) = (k,v)
pq_min_entry (PQ_MT) = abort "empty pq"

pq_min_key :: (PQ k v) -> k | Ord k
pq_min_key (PQ_LF k _ _ _) = k
pq_min_key (PQ_MT) = abort "empty pq"

pq_min_val :: (PQ k v) -> v | Ord k
pq_min_val (PQ_LF _ v _ _) = v
pq_min_val (PQ_MT) = abort "empty pq"

pq_min_entry_rest :: (PQ k v) -> ((k,v), (PQ k v)) | Ord k
pq_min_entry_rest q = (pq_min_entry q, pq_delete_min q)

pq_min_key_rest :: (PQ k v) -> (k, (PQ k v)) | Ord k
pq_min_key_rest q = (pq_min_key q, pq_delete_min q)

pq_min_val_rest :: (PQ k v) -> (v, (PQ k v)) | Ord k
pq_min_val_rest q = (pq_min_val q, pq_delete_min q)

pq_delete_min :: (PQ k v) -> (PQ k v) | Ord k
pq_delete_min (PQ_MT) = abort "empty pq"
pq_delete_min (PQ_LF _ _ _ []) = PQ_MT
pq_delete_min (PQ_LF _ _ _ l) = PQ_LF k0 v0 0 (fold_skewinsert zs l2)
  where l2 = skew_meld (skeld_meld ts1 ts2) l1
        (zs,ts1,l1) = split r0 [] [] cf0
        (PQ_LF k0 v0 r0 cf0, ts2) = get_min l

pq_init :: [(k,v)] -> PQ k v | Ord k
pq_init kvs = loop kvs (PQ_MT)
  where loop [(k,v):kvs] q = loop kvs (pq_insert k v q)
        loop []          q = q

pq_zip :: [k] [v] -> PQ k v | Ord k
pq_zip ks vs = loop ks vs (PQ_MT)
  where loop [k:ks] [v:vs] q = loop ks vs (pq_insert k v q)
        loop _      _      q = q

pq_entry_list :: (PQ k v) -> [(k,v)] | Ord k
pq_entry_list (PQ_MT) = []
pq_entry_list q = [pq_min_entry q, pq_entry_list (delete_min q)]

pq_key_list :: (PQ k v) -> [k] | Ord k
pq_key_list (PQ_MT) = []
pq_key_list q = [pq_min_key q, pq_key_list (delete_min q)]

pq_val_list :: (PQ k v) -> [k] | Ord k
pq_val_list (PQ_MT) = []
pq_val_list q = [pq_min_val q, pq_val_list (delete_min q)]


------------ more internal functions to come --------------------


